// NSDictionary+Letter.h -- category on NS[Mutable]Dictionary to handle the 
//                          letter translation stuff.

#import <Foundation/Foundation.h>


@interface NSDictionary(LetterTranslation)

// map from one letter (the original letter in the cryptogram) to
// its replacement.  If a translation is not found, the letterString
// argument is returned

- (NSString *) translateLetter: (NSString *) letterString;

@end // LetterTranslation category



@interface NSMutableDictionary(LetterTranslation)

// throw out all the mappings, and replace it with "A=A, B=B, C=C ..."

- (void) resetTranslationToIdentity;


// change one letter to another.  It is a 1:1 mapping, so the
// current letter that is mapped to the original is swapped with
// the new letter.

- (void) setTranslatedLetter: (NSString *) letter
           forOriginalLetter: (NSString *) original;

@end // LetterTranslation category
